#ifndef DLLAPPS_H
#define DLLAPPS_H

#include <unistd.h>
#include "regex.h"
#include "types.h"
#include "acl.h"
#include "config.h"

#define	CTYPE_REGEX	2
#define	CTYPE_ACL	3
#define	CTYPE_PID	4
#define	CTYPE_FILTER	5

typedef struct dlr_s {	struct dlr_s	*next;
			struct dlr_s	*prev;
			INT		ctype;
			INT		mark;
			INT		filter;
			CHAR		*map;
			regex_t		compiled;
			CHAR		*raw;		} dlr_t;

typedef struct dla_s {	struct dla_s	*next;
			struct dla_s	*prev;
			INT		ctype;
			INT		mark;
			struct acl_s	acl;		} dla_t;

typedef struct dlp_s {	struct dlp_s	*next;
			struct dlp_s	*prev;
			INT		ctype;
			INT		mark;
			uid_t		uid;
			gid_t		gid;
			pid_t		pid;
			pid_t		ppid;
			INT		signal;		} dlp_t;

typedef struct dlf_s {	struct dlf_s	*next;
			struct dlf_s	*prev;
			INT		ctype;
			INT		mark;
			CHAR		*rxfilter;
			CHAR		*txfilter;	} dlf_t;

#define filepat rxfilter
#define filemap txfilter

in_addr_t xinet_addr(CHAR *host, INT resolv);
VOID clearReChain(dlr_t *head);
VOID clearPidChain(dlp_t *head);
VOID clearFilterChain(dlf_t *head);
VOID deleteReChain(dlr_t *head);
VOID deletePidChain(dlp_t *head);
VOID deleteACLChain(dla_t *head);
VOID deleteFilterChain(dlf_t *head);
dlr_t *initReChain(VOID);
dla_t *initACLChain(VOID);
dlp_t *initPidChain(VOID);
dlf_t *initFilterChain(VOID);
VOID deleteACLByMark(dla_t *head, INT mark);
VOID deleteFilterByMark(dlf_t *head, INT mark);
VOID deleteReByMark(dlr_t *head, INT mark);
INT deleteByPid(dlp_t *head, pid_t pid);
dlr_t *findRePattern(dlr_t *head, dlr_t *start, INT mark, CHAR *name);
dla_t *findACL(dla_t *head, dla_t *start, INT mark, in_addr_t addr);
dlp_t *findPid(dlp_t *head, pid_t pid);
dla_t *getACLByMark(dla_t *head, dla_t *start, INT mark);
dlf_t *getFilterByMark(dlf_t *head, dlf_t *start, INT mark);
dlr_t *getReByMark(dlr_t *head, dlr_t *start, INT mark);
dlr_t *getNextRe(dlr_t *head, dlr_t *start);
dla_t *getNextACL(dla_t *head, dla_t *start);
dlp_t *getNextPid(dlp_t *head, dlp_t *start);
INT getPidCount(dlp_t *head);
dlf_t *getNextFilter(dlf_t *head, dlf_t *start);
INT addRePattern(dlr_t *head, INT mark, CHAR *pattern, CHAR *map, INT filter, dlr_t **np);
INT addACL(dla_t *head, INT mark, INT perm, CHAR *addr, CHAR *mask, dla_t **np);
INT addPid(dlp_t *head, INT mark, pid_t pid, pid_t ppid, INT signal, uid_t uid, gid_t gid, dlp_t **np);
INT addFilter(dlf_t *head, INT mark, CHAR *rxf, CHAR *txf, dlf_t **np);
VOID sortFilterByMark(dlf_t *head, INT mode);
VOID modifyPLE (dlp_t *pp, pid_t pid, pid_t ppid, INT signal, uid_t uid, gid_t gid);
#endif /* DLLAPPS_H */
